' FFSubmenu=GPS
' FFName=Umfeldsuche
' Bilder im Umfeld in einer Bilderliste gesammelt
' ** KGsoft (Andreas Kleingnther) 
' Version 0.5 vom 06.11.2016	
' Version 1.0 vom 27.12.2020	erste ffentliche Version	

Option Explicit
Const ver = "V 1.0 (12/20)"
Dim Taste
Dim startFolder
Dim Ordner
Dim searchMask
Dim searchLevel
Dim Bilderliste()
Dim ZAblage, Ablageteil
Dim LaengeM, BreiteM	' Koordinaten des Mittelpunktes
Dim LaengeB, BreiteB	' Koordinaten des zu prfenden Bildes
Dim Suchradius			' in km
Dim geourl
Dim geo_ok
Dim i, u
Const BListName = "Umfeldsuche"
Const Suchmuster_Geo = "^(\+|-)?[0-9]+[.][0-9]*\s*[,]\s*(\+|-)?[0-9]+[.][0-9]+$"    
	' Koordinaten aus Zwischenablage: optionales Vorzeichen / beliebieg Ziffern / Punkt /beliebige Ziffern / Komma, opional mit Leerzeichen / optionales Vorzeichen / beliebieg Ziffern / Punkt /beliebige Ziffern
Dim Geobild
Dim Sechsziffer, Zahl
Dim Startzeit, Endzeit
Dim Maptyp, MapZoom
Dim Quelltyp		' 1 = Computeransicht, 2 = Arbeitsbereich, 3 = Zwischenablage
Dim radiusliderwert
Dim einmal
Dim wshshell
Set wshshell = CreateObject("WScript.Shell")

' fr Hilfe
Dim Taste2
Dim objFs, Kurzbeschreibung, KBvorhanden, LaengeMax
REM Dim WshShell
const SkriptName = "umfeldsuche.vbs"			' Skriptname


Call Dialogaufbau
Call Main

Sub Main
	' Startwerte
	Quelltyp = 1									' Bild aus Computeransicht
	startFolder = FF_GetImagePath					' aktuelles Bildverzeichnis
	FF_SetControl "Umfeldsuche","bool_uo", "1"
	FF_SetDialogTimer "Umfeldsuche", 200	
	FF_SetControl "Umfeldsuche","compansicht_bol", 1
	FF_SetControl "Umfeldsuche", "hybrid_bol", 1
	Maptyp = "hybrid"
	einmal = 1
	
	Do
		Taste = FF_ShowDialog("Umfeldsuche")
		Select Case Taste
			Case "TIMER"
				If einmal = 1 Then 
					FF_SetControl "Umfeldsuche","|", startFolder
					einmal = 0
				end if
				radiusliderwert = FF_GetControl ("Umfeldsuche", "radius_slide")
				FF_SetControl "Umfeldsuche", "radius", Radiuswert(radiusliderwert)				
				FF_SetControl "Umfeldsuche","img_kreis",""		' Geo-Bild lschen (scheint der Stabilitr frderlich)
				Call Quell_GeoDatum
			Case "compansicht_bol"
				FF_SetControl "Umfeldsuche", "compansicht_bol", 1
				FF_SetControl "Umfeldsuche", "abereich_bol", 0
				FF_SetControl "Umfeldsuche", "zwanlage_bol", 0
				Quelltyp = 1
			Case "abereich_bol"
				FF_SetControl "Umfeldsuche", "compansicht_bol", 0
				FF_SetControl "Umfeldsuche", "abereich_bol", 1
				FF_SetControl "Umfeldsuche", "zwanlage_bol", 0	
				Quelltyp = 2				
			Case "zwanlage_bol"
				FF_SetControl "Umfeldsuche", "compansicht_bol", 0
				FF_SetControl "Umfeldsuche", "abereich_bol", 0
				FF_SetControl "Umfeldsuche", "zwanlage_bol", 1
				Quelltyp = 3
			Case "strae_bol"
				FF_SetControl "Umfeldsuche", "strae_bol", 1
				FF_SetControl "Umfeldsuche", "satellit_bol", 0
				FF_SetControl "Umfeldsuche", "hybrid_bol", 0
				FF_SetControl "Umfeldsuche", "gelaende_bol", 0
				Maptyp = "roadmap"
			Case "satellit_bol"
				FF_SetControl "Umfeldsuche", "strae_bol", 0
				FF_SetControl "Umfeldsuche", "satellit_bol", 1
				FF_SetControl "Umfeldsuche", "hybrid_bol", 0
				FF_SetControl "Umfeldsuche", "gelaende_bol", 0
				Maptyp = "satellite"
			Case "hybrid_bol"
				FF_SetControl "Umfeldsuche", "strae_bol", 0
				FF_SetControl "Umfeldsuche", "satellit_bol", 0
				FF_SetControl "Umfeldsuche", "hybrid_bol", 1
				FF_SetControl "Umfeldsuche", "gelaende_bol", 0			
				Maptyp = "hybrid"
			Case "gelaende_bol"
				FF_SetControl "Umfeldsuche", "strae_bol", 0
				FF_SetControl "Umfeldsuche", "satellit_bol", 0
				FF_SetControl "Umfeldsuche", "hybrid_bol", 0
				FF_SetControl "Umfeldsuche", "gelaende_bol", 1
				Maptyp = "terrain"
			Case "Ordner"														' Startordner Bildersuche festlegen
				Ordner = FF_EnterPath(false,"Ordner auswhlen!")
				if Ordner <> "" Then											' Ordnerauswahl nicht abgebrochen
					startFolder = Ordner
				end If
				FF_SetControl "Umfeldsuche","|", startFolder
			Case "Suche"
				Quell_GeoDatum													' sicherheisthalber Aktualisierung des Suchbereichs
				if geo_ok = true Then
					Call Dateisuche
					FF_SetControl "Umfeldsuche","||", ubound(Bilderliste)+1	 		' zu prfende Bilddateien
					Call Geovergleich
					FF_SetControl "Umfeldsuche","|||", Geobild						' Anzahl Bilder mit Koordinaten
					FF_SetControl "Umfeldsuche","||||", FF_IListGetCount(BListName)	' Treffer (Bild im Umfeld)
				End If
			Case "Schlieen", "CANCEL"
				Exit Do
			Case "?"
				REM WSHShell.Run Chr(34) & FF_GetFFPathEx(2) & "\Koordinatenzuweisen\Koordinaten_zuweisen.pdf" & Chr(34)
				Call Help				
		End Select
	Loop
End Sub

Sub Quell_GeoDatum
	geo_ok = false
	Select case Quelltyp
		Case 1				' Bild Computer-Ansicht			
			If FF_GetImageCount > 0 Then
				FF_LoadExif (FF_GetImageName(0))
				BreiteM = FF_GetExifTag("Latitude")
				LaengeM = FF_GetExifTag("Longitude")
				if Len(BreiteM) > 0 Then									' nur wenn Geodaten vorhanden sind
					BreiteM = grad2decimal(BreiteM)
					LaengeM = grad2decimal(LaengeM)
					BreiteM = Replace(BreiteM, ".", ",")
					LaengeM = Replace(LaengeM, ".", ",")		' Punkt zu Komma
					BreiteM = CDbl(BreiteM)
					LaengeM = CDbl(LaengeM)						' Umwandlung von String zu Double
					geo_ok = true
					FF_SetControl "Umfeldsuche","mpunkt", BreiteM & "," & LaengeM
				End If
			End If
			if geo_ok = False then 
					FF_SetControl "Umfeldsuche","mpunkt", "keine gltigen Koordinaten"
			end if
		Case 2				' Bild auf Arbeitsflche geladen und schon mal gespeichert
			If Len(FF_GetImageName(-1)) > 0 Then	
				FF_LoadExif (FF_GetImageName(-1))
				BreiteM = FF_GetExifTag("Latitude")
				LaengeM = FF_GetExifTag("Longitude")
				if Len(BreiteM) > 0 Then									' nur wenn Geodaten vorhanden sind
					BreiteM = grad2decimal(BreiteM)
					LaengeM = grad2decimal(LaengeM)
					BreiteM = Replace(BreiteM, ".", ",")
					LaengeM = Replace(LaengeM, ".", ",")		' Punkt zu Komma
					BreiteM = CDbl(BreiteM)
					LaengeM = CDbl(LaengeM)						' Umwandlung von String zu Double
					geo_ok = true
					FF_SetControl "Umfeldsuche","mpunkt", BreiteM & "," & LaengeM
				End If
			End If
			if geo_ok = False then 
					FF_SetControl "Umfeldsuche","mpunkt", "keine gltigen Koordinaten"
			end if
		Case 3				' Zwischenablage	
			ZAblage = FF_TextFromClipboard()
			REM ZAblage = "50.272907,12.276607" 			' fr Testzwecke
			ZAblage = Replace(zablage, vbNewLine, "")		' ggf. fhrenden Zeilenumbruch entfernen
			If SearchRegAusdr (ZAblage, Suchmuster_Geo, False) = True Then
				Ablageteil = Split (ZAblage, ",")
				BreiteM = Ablageteil(0)		' Breite
				LaengeM = Ablageteil(1)		' Lnge
				BreiteM = Replace(BreiteM, ".", ",")
				LaengeM = Replace(LaengeM, ".", ",")		' Punkt zu Komma
				BreiteM = CDbl(BreiteM)
				LaengeM = CDbl(LaengeM)						' Umwandlung von String zu Double
				FF_SetControl "Umfeldsuche","mpunkt", ZAblage
				geo_ok = true
			Else
				FF_SetControl "Umfeldsuche","mpunkt", "keine gltigen Koordinaten"
			end If
		End Select
	Suchradius = FF_GetControl ("Umfeldsuche", "radius")		
	If IsNumeric(Suchradius) = true Then 
		Suchradius = CCur(Suchradius)
	Else
		MsgBox "Der Suchradius muss angegeben werden.", 48
		Exit Sub
	End If
	
	if geo_ok = true Then
		geourl = GMapCircle(BreiteM,LaengeM,Suchradius * 1000 ,8, Maptyp, MapZoom) 	' Suchradius hier in Meter
		FF_LoadURL geourl, FF_GetScriptPath & "\geotemp.png"
		FF_SetControl "Umfeldsuche","img_kreis", FF_GetScriptPath & "\geotemp.png"
	end If
End Sub

Sub Dateisuche
	searchMask = "\.jpe?g"		' passt auf .jpeg und .jpg
	if FF_GetControl ("Umfeldsuche","bool_uo") = "1" Then			' mit Unterverzeichnissen
		searchLevel = 2
	Else
		searchLevel = 1
	End If
	Call Dialogaufbau2				' muss nach jedem FF_CloseDialog neu erstellt werden
	FF_OpenDialog "Fortschritt"	
	BuildFileList startFolder, searchMask, searchLevel, Bilderliste	
	FF_CloseDialog "Fortschritt"
End Sub
 
Sub Geovergleich
	' erwartet BreiteM, LaengeM, Suchradius 
	Geobild = 0
	FF_IListDelete(BListName)
	FF_IListCreate(BListName)
	Call Dialogaufbau2				' muss nach jedem FF_CloseDialog neu erstellt werden
	FF_OpenDialog "Fortschritt"
	u = ubound(Bilderliste)
	If len(Bilderliste(0)) > 1 Then		'Index 0 kann auch eine leere Liste bedeuten, dies abfangen
		for i = 0 to u
			if (u-i) mod 11 = 1 Then
				REM msgbox "Fortschritt : " & u-i
				Fortschritt_Anzeige u-i
			End If
				FF_LoadExif (Bilderliste(i))
				BreiteB = FF_GetExifTag("Latitude")		' Breite
				LaengeB = FF_GetExifTag("Longitude")	' Lnge
				if Len(BreiteB) > 0 And Len(LaengeB) > 0 Then	' Bild hat Koordinaten
					Geobild = Geobild + 1
					BreiteB = grad2decimal(BreiteB)
					LaengeB = grad2decimal(LaengeB)
					If GeoDistanz(BreiteM,LaengeM,BreiteB,LaengeB) <= Suchradius Then		
						FF_IListInsertFile BListName, Bilderliste(i), -1
					End If
				End If
		next
	end if
	FF_CloseDialog "Fortschritt"
	FF_IListSave BListName
End Sub

Sub Dialogaufbau
	'** Start Dialog Umfeldsuche **
	FF_AddDialog "Umfeldsuche",424,256
	FF_AddControl "Umfeldsuche","Kartentyp","GROUP",7,130,153,24
	FF_AddControl "Umfeldsuche","Quelle fr Mittelpunkt","GROUP",7,73,153,36
	FF_AddControl "Umfeldsuche","Ergebnisse","GROUP",2,170,163,64
	FF_AddControl "Umfeldsuche","Suchkreis festlegen","GROUP",2,60,163,101
	FF_AddControl "Umfeldsuche","Suchpfad","GROUP",2,4,163,47
	FF_AddControl "Umfeldsuche","mpunkt","EDIT",81,96,75,10
	FF_SetControlStyle "Umfeldsuche","mpunkt",1
	FF_AddControl "Umfeldsuche","Mittelpunkt (Breite, Lnge):","STATIC",13,96,68,11
	FF_AddControl "Umfeldsuche","Radius in km:","STATIC",9,115,35,11
	FF_AddControl "Umfeldsuche","Ergebnis-Bilderliste:","STATIC",8,179,75,11
	FF_AddControl "Umfeldsuche","Suche","BUTTON",127,240,33,11
	FF_AddControl "Umfeldsuche","|","STATIC",9,26,154,11
	FF_AddControl "Umfeldsuche","bool_uo","BOOL",13,39,8,8
	FF_AddControl "Umfeldsuche","mit Unterordnern","STATIC",24,37,56,11
	FF_AddControl "Umfeldsuche","Umfeldsuche","STATIC",94,179,43,11
	FF_AddControl "Umfeldsuche","Schlieen","BUTTON",89,240,33,11
	FF_AddControl "Umfeldsuche","geprfte Bilder:","STATIC",8,192,58,11
	FF_AddControl "Umfeldsuche","Treffer im Suchkreis:","STATIC",8,217,61,11
	FF_AddControl "Umfeldsuche","||","STATIC",94,192,33,11
	FF_SetControlStyle "Umfeldsuche","||",2
	FF_AddControl "Umfeldsuche","|||","STATIC",94,204,33,11
	FF_SetControlStyle "Umfeldsuche","|||",2
	FF_AddControl "Umfeldsuche","img_kreis","IMAGE",171,3,250,250
	FF_AddControl "Umfeldsuche","Bilder mit Standortinformationen:","STATIC",8,204,83,11
	FF_AddControl "Umfeldsuche","||||","STATIC",94,217,33,11
	FF_SetControlStyle "Umfeldsuche","||||",2
	FF_AddControl "Umfeldsuche","Strae","STATIC",25,138,26,12
	FF_AddControl "Umfeldsuche","radius","SLEDIT",44,115,16,11
	FF_SetControlStyle "Umfeldsuche","radius",2048
	FF_AddControl "Umfeldsuche","Ordner","BUTTON",9,13,55,12
	FF_AddControl "Umfeldsuche","radius_slide","HSLIDER",65,111,91,15
	FF_AddControl "Umfeldsuche","strae_bol","BOOL",13,140,8,8
	FF_SetControlStyle "Umfeldsuche","strae_bol",16384
	FF_AddControl "Umfeldsuche","satellit_bol","BOOL",48,140,8,8
	FF_SetControlStyle "Umfeldsuche","satellit_bol",16384
	FF_AddControl "Umfeldsuche","Satellit","STATIC",60,139,22,11
	FF_AddControl "Umfeldsuche","gelaende_bol","BOOL",123,140,8,8
	FF_SetControlStyle "Umfeldsuche","gelaende_bol",16384
	FF_AddControl "Umfeldsuche","Gelnde","STATIC",135,139,24,11
	FF_AddControl "Umfeldsuche","compansicht_bol","BOOL",13,84,8,8
	FF_SetControlStyle "Umfeldsuche","compansicht_bol",16384
	FF_AddControl "Umfeldsuche","Comp-Ansicht","STATIC",24,82,38,11
	FF_AddControl "Umfeldsuche","zwanlage_bol","BOOL",113,84,8,8
	FF_SetControlStyle "Umfeldsuche","zwanlage_bol",16384
	FF_AddControl "Umfeldsuche","Zwischenabl.","STATIC",123,82,35,11
	FF_AddControl "Umfeldsuche","hybrid_bol","BOOL",84,140,8,8
	FF_SetControlStyle "Umfeldsuche","hybrid_bol",16384
	FF_AddControl "Umfeldsuche","Hybrid","STATIC",96,138,22,11
	FF_AddControl "Umfeldsuche","abereich_bol","BOOL",66,84,8,8
	FF_SetControlStyle "Umfeldsuche","abereich_bol",16384
	FF_AddControl "Umfeldsuche","Arbeitsber.","STATIC",77,82,33,11
	FF_AddControl "Umfeldsuche","?","BUTTON",8,240,15,11
	FF_AddControl "Umfeldsuche",ver,"STATIC",31,240,43,11
	'** End Dialog Umfeldsuche **
End Sub

Sub Fortschritt_Anzeige (ByVal Sechsziffer)
	' erwartet eine Zahl mit maximal sechs Ziffern
	if len(Sechsziffer) < 6 then
		Zahl = string(6-len(Sechsziffer), "0") & Sechsziffer
	else
		Zahl = Sechsziffer
	end if
	FF_SetControl "Fortschritt", "einer", FF_GetScriptPath & "\" & Mid(zahl,6,1) &".jpg"
	FF_SetControl "Fortschritt", "zehner", FF_GetScriptPath & "\" & Mid(zahl,5,1) &".jpg"
	FF_SetControl "Fortschritt", "hunderter", FF_GetScriptPath & "\" & Mid(zahl,4,1) &".jpg"
	FF_SetControl "Fortschritt", "tausender", FF_GetScriptPath & "\" & Mid(zahl,3,1) &".jpg"
	FF_SetControl "Fortschritt", "zehntausender", FF_GetScriptPath & "\" & Mid(zahl,2,1) &".jpg"
	FF_SetControl "Fortschritt", "hunderttausender", FF_GetScriptPath & "\" & Mid(zahl,1,1) &".jpg"
	FF_RefreshDialog "Fortschritt"
end sub

Sub Dialogaufbau2
	'** Start Dialog Fortschritt **
	FF_AddDialog "Fortschritt",94,63
	FF_AddControl "Fortschritt","hunderttausender","IMAGE",7,36,14,20
	FF_AddControl "Fortschritt","zehntausender","IMAGE",20,36,14,20
	FF_AddControl "Fortschritt","tausender","IMAGE",33,36,14,20
	FF_AddControl "Fortschritt","hunderter","IMAGE",46,36,14,20
	FF_AddControl "Fortschritt","zehner","IMAGE",59,36,14,20
	FF_AddControl "Fortschritt","einer","IMAGE",72,36,14,20
	FF_AddControl "Fortschritt","geprfte Dateien","GROUP",3,26,87,34
	FF_AddControl "Fortschritt","Fortschritt luft ...","STATIC",3,11,54,11
	FF_AddControl "Fortschritt","Einen Moment bitte.","STATIC",3,2,53,11
	'** End Dialog Fortschritt **
End Sub	

Function GeoDistanz (ByVal Latitude_1, ByVal Longitude_1, ByVal Latitude_2, ByVal Longitude_2) 
' berechnet Abstand zwischen zwei Koordinatenpunkten in Kilometern
' erwartet die Koordinaten im Deziamlformat Breite1, Lnge1, Breite2, Lnge2 (wie Google Maps)
' bentigt die Funktione acos()
	Dim pi
	pi = 4 * Atn(1)
	if Len(Latitude_1) > 0 and Len(Latitude_2) > 0 Then	
		' wegen Zahlenformat Punkt durch Komma ersetzen
		Latitude_1 = Replace(Latitude_1,".",",")
		Longitude_1 = Replace(Longitude_1,".",",")
		Latitude_2 = Replace(Latitude_2,".",",")
		Longitude_2 = Replace(Longitude_2,".",",")
		
		'Umrechung in Bogenma
		Latitude_1 = Latitude_1*pi/180
		Longitude_1 = Longitude_1*pi/180
		Latitude_2 = Latitude_2*pi/180
		Longitude_2 = Longitude_2*pi/180

		GeoDistanz = 6378.388 * acos(sin(Latitude_1) * sin(Latitude_2) + cos(Latitude_1) * cos(Latitude_2) * cos(Longitude_2 - Longitude_1))
		GeoDistanz = Round(GeoDistanz, 3)
	End If
End Function
	
Function acos(X)
'Arkuskosinus
	On Error Resume Next					' Divison durch Null abfangen, wenn identische Standorte
	acos = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
End Function

'********************************************
'* grad2decimal wandelt  ' " in dezimal
'********************************************
Function grad2decimal(ByVal p_Str)
	dim l_Richtung
	dim l_Pos
	dim l_Wert

	if p_Str<>"" then
		p_Str=replace(p_Str,".",",",1)
		l_Richtung=left(p_Str,1)
		p_Str=ltrim(right(p_Str,len(p_Str)-1))
		l_Pos=instr(p_Str,"")
		'msgbox l_Wert
		l_Wert=1.0*(left(p_Str,l_Pos-1))
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"'")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/60
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"""")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/3600
		Select Case l_Richtung
			Case "s", "S", "w", "W"
				grad2decimal="-" & replace(FormatNumber(l_Wert,6),",",".",1)
			case Else
				grad2decimal=replace(FormatNumber(l_Wert,6),",",".",1)
		End Select
	else
		grad2decimal=""
	end if
end function

'*********************************************************
' BuildFileList baut eine Dateiliste auf
' bentigt die Klasse clsFindFile
' startFolder : Startverzeichnis
' searchMask  : Suchmaske fr die Dateien (reg. Ausdruck)		' akg
' searchLevel : 0 = markierte Bilder
'               1 = aktuelles Verzeichnis
'               2 = aktuelles und alle Unterverzeichnisse
' pics        : Array mit den gefundenen Pfadnamen
'*********************************************************
sub BuildFileList(startFolder, searchMask, searchLevel, byref pics)
	dim oFindF
	dim recursive
	dim i, msg
	redim preserve pics(0)
	pics(0) = ""
	if searchLevel = 0 then
		for i=0 to FF_GetImageCount-1
			redim preserve pics(i)
			pics(i) = FF_GetImageName(i)
		next
	else
		recursive = eval(searchLevel=2)
		set oFindF = new clsFindFile
		oFindF.findFiles startFolder, searchMask, recursive, pics
		set oFindF = nothing
	end if
end sub

'*********************************************************
' clsFindFile durchsucht rekursiv einen Dateibaum nach
' Dateinamen
'*********************************************************
Class clsFindFile

	private mvFso
	private mvRegEx

    ''''''''''''''''''''''''''''''''''''''''
	Private Sub Class_Initialize()
    ''''''''''''''''''''''''''''''''''''''''
		set mvFso=CreateObject("Scripting.FileSystemObject")
		Set mvRegEx = new regexp
	end sub

    ''''''''''''''''''''''''''''''''''''''''
	public sub findFiles(strFolder, pattern, recursive, byref fileList)
    ''''''''''''''''''''''''''''''''''''''''

		dim startFolder
		dim nfiles
		set startFolder=mvFso.GetFolder(strFolder)

		mvRegEx.Pattern = pattern
		mvRegEx.IgnoreCase = true
		nfiles = 0

		scanFolder startFolder, recursive, nFiles, fileList
	end sub

    ''''''''''''''''''''''''''''''''''''''''
	private sub scanFolder (byref folder, recursive, nFiles, byref fileList)
    ''''''''''''''''''''''''''''''''''''''''
		dim f, subF, FileName
		for each f in folder.Files
			on error resume next
			FileName = mvFso.GetBaseName(f) & "." & mvFso.GetExtensionName(f)
			if mvRegEx.Test(FileName) then
				redim preserve fileList(nFiles)
				fileList(nFiles) = f
				nFiles = nFiles + 1
				' ** Fortschrittsanzeige
					REM Call Fortschritt_Anzeige (nFiles)	' Aufruf exteren Sub von hier aus funktioniert nicht, daher direkt eingeschoben
					if nFiles mod 11 = 1 Then		' nur bei jedem 11. Treffer
						Sechsziffer = nFiles
						if len(Sechsziffer) < 6 then
								Zahl = string(6-len(Sechsziffer), "0") & Sechsziffer
							else
								Zahl = Sechsziffer
							end if
							FF_SetControl "Fortschritt", "einer", FF_GetScriptPath & "\" & Mid(zahl,6,1) &".jpg"
							FF_SetControl "Fortschritt", "zehner", FF_GetScriptPath & "\" & Mid(zahl,5,1) &".jpg"
							FF_SetControl "Fortschritt", "hunderter", FF_GetScriptPath & "\" & Mid(zahl,4,1) &".jpg"
							FF_SetControl "Fortschritt", "tausender", FF_GetScriptPath & "\" & Mid(zahl,3,1) &".jpg"
							FF_SetControl "Fortschritt", "zehntausender", FF_GetScriptPath & "\" & Mid(zahl,2,1) &".jpg"
							FF_SetControl "Fortschritt", "hunderttausender", FF_GetScriptPath & "\" & Mid(zahl,1,1) &".jpg"
							FF_RefreshDialog "Fortschritt"
						end If
				' ** Fortschrittsanzeige
			end if
		next
		if recursive then
			for each subF in folder.SubFolders
				scanFolder subF, recursive, nFiles, fileList
			next
		end if
	end sub

    ''''''''''''''''''''''''''''''''''''''''
	Private Sub Class_Terminate
    ''''''''''''''''''''''''''''''''''''''''
        Set mvFSO = Nothing
        Set mvRegEx = Nothing
	End Sub

end Class

Function GMapCircle(lat,lng,rad,detail, Maptyp, MapZoom)
	' zeichnet mittels Googel Maps Static API einen Polygon-Kreis um einen gegebenen Punkt
	' Lnge und Breite im Dezimalformat
	' Radius in Metern
	' Detail = Bruchteil von 360 = Anzahl der Polygone (sinnvoller Wert = 8)
	' MapTyp = roadmap hybrid satellite terrain
	' MapZoom = 0-12 oder -1 fr Automatik
	
	Dim uri
	Dim staticMapSrc
	Dim r
	dim pi 
	pi = 3.14159
	Dim lat_1
	Dim lng_1
	Dim brng
	Dim pLat, pLng
	Dim d
	Dim i 
	Const apikey = "&key=AIzaSyDz0gvDvggrHqIS4k-ijffnjhe5v56ooeE"

	uri = "http://maps.googleapis.com/maps/api/staticmap?"						' FF_LoadURL geht nicht mit https
	'staticMapSrc = "center=" & lat & "," & lng									' entbehrlich, da ein Marker gesetzt wird
	staticMapSrc = staticMapSrc & "&markers=color:0x0000ff|" & lat & "," & lng	' Marker blau
	if MapZoom >= 0 Then
		staticMapSrc = staticMapSrc & "&zoom=" & MapZoom
	End If
	staticMapSrc = staticMapSrc & "&size=640x640&scale=1"   					' max 640x640 scale=2 fhrt zur Verdoppelung 			
	staticMapSrc = staticMapSrc & "&maptype=" & MapTyp							' roadmap hybrid satellite terrain 
	staticMapSrc = staticMapSrc & "&path=color:0x0000ffff|weight:1"				' blau, volle Deckkraft (ff am Ende), Breite 2 pxl
	
	r = 6371
	lat_1 = (lat * pi) / 180
	lng_1  = (lng * pi) / 180
	d = (rad/1000) / r
	i = 0
	
	For i = 0 to 360 step detail
		brng = i * pi /180
		pLat = ASin(sin (lat_1) * cos (d) + Cos(lat_1) * sin(d) * cos (brng))
		pLng = ((lng_1 + Atan2(sin(brng) * Sin(d) * Cos(lat_1), Cos(d) - Sin(lat_1) * Sin(pLat))) * 180) / pi
		pLat = (pLat * 180) / pi
		staticMapSrc = staticMapSrc & "|" & pLat & "," & pLng
	next
	GMapCircle = uri & staticMapSrc & apikey
End Function

'Arkussinus
Function ASin(X)
	ASin = Atn(X / Sqr(-X * X + 1))
End Function

Function Atan2(ys, xs)
	' Given y and x coords returns atan2
	' by Jim Deutch, Syracuse, New York
	Dim theta, pi
    pi = 3.1415926535897932384626433832795
    If xs <> 0 Then
        theta = Atn(ys / xs)
        If xs < 0 Then
            theta = theta + pi
        End If
    Else
        If ys < 0 Then
            theta = 3 * pi / 2 	'90
        Else
            theta = pi / 2 		'270
        End If
    End If
	Atan2 = theta
End Function

Function SearchRegAusdr(Zeichenfolge, Muster, GrossKleinBeachten)
' Vergleich einer Zeichenfolge mit einem Suchmuster, bei bereinstimmung
' wird True zurckgegeben, sonst False
    Dim regAusdr
    Set regAusdr = New RegExp
    regAusdr.Pattern = Muster
    regAusdr.IgnoreCase = GrossKleinBeachten    ' Bercksichtigung der Gro-/Kleinschreibung
    regAusdr.Global = True                      ' legt globales Anwenden fest
    If regAusdr.Test(Zeichenfolge) then
        SearchRegAusdr = True
    Else
        SearchRegAusdr = False
    End If
End Function

Function FirstPicture
	' gibt den Pfad des ersten markierten Bildes in der Compureransicht zurck
	If instr(FF_GetSelection(1), vbNewLine) > 0 Then		' mehr als ein Bild markiert
		FirstPicture = Left(FF_GetSelection(1),Instr(FF_GetSelection(1),vbNewLine)-1)
	Else													' ein oder kein Bild markiert
		FirstPicture = FF_GetSelection(1)
	End If
End Function

Function Radiuswert (sliderwert)
	' leiter vom Wert des Sliders (1 - 255) eine Kilometerangabe ab (s. 
	if sliderwert < 5 THEN Radiuswert = 0.1
	if sliderwert >=  5 AND sliderwert <  10 THEN Radiuswert = 0.2
	if sliderwert >=  10 AND sliderwert <  15 THEN Radiuswert = 0.5
	if sliderwert >=  15 AND sliderwert <  20 THEN Radiuswert = 1
	if sliderwert >=  20 AND sliderwert <  25 THEN Radiuswert = 1.5
	if sliderwert >=  25 AND sliderwert <  30 THEN Radiuswert = 2
	if sliderwert >=  30 AND sliderwert <  35 THEN Radiuswert = 2.5
	if sliderwert >=  35 AND sliderwert <  40 THEN Radiuswert = 5
	if sliderwert >=  40 AND sliderwert <  45 THEN Radiuswert = 10
	if sliderwert >=  45 AND sliderwert <  50 THEN Radiuswert = 15
	if sliderwert >=  50 AND sliderwert <  55 THEN Radiuswert = 20
	if sliderwert >=  55 AND sliderwert <  60 THEN Radiuswert = 25
	if sliderwert >=  60 AND sliderwert <  65 THEN Radiuswert = 30
	if sliderwert >=  65 AND sliderwert <  70 THEN Radiuswert = 35
	if sliderwert >=  70 AND sliderwert <  75 THEN Radiuswert = 40
	if sliderwert >=  75 AND sliderwert <  80 THEN Radiuswert = 45
	if sliderwert >=  80 AND sliderwert <  85 THEN Radiuswert = 50
	if sliderwert >=  85 AND sliderwert <  90 THEN Radiuswert = 55
	if sliderwert >=  90 AND sliderwert <  95 THEN Radiuswert = 60
	if sliderwert >=  95 AND sliderwert <  100 THEN Radiuswert = 65
	if sliderwert >=  100 AND sliderwert <  105 THEN Radiuswert = 70
	if sliderwert >=  105 AND sliderwert <  110 THEN Radiuswert = 75
	if sliderwert >=  110 AND sliderwert <  115 THEN Radiuswert = 80
	if sliderwert >=  115 AND sliderwert <  120 THEN Radiuswert = 100
	if sliderwert >=  120 AND sliderwert <  125 THEN Radiuswert = 120
	if sliderwert >=  125 AND sliderwert <  130 THEN Radiuswert = 140
	if sliderwert >=  130 AND sliderwert <  135 THEN Radiuswert = 160
	if sliderwert >=  135 AND sliderwert <  140 THEN Radiuswert = 180
	if sliderwert >=  140 AND sliderwert <  145 THEN Radiuswert = 200
	if sliderwert >=  145 AND sliderwert <  150 THEN Radiuswert = 250
	if sliderwert >=  150 AND sliderwert <  155 THEN Radiuswert = 300
	if sliderwert >=  155 AND sliderwert <  160 THEN Radiuswert = 350
	if sliderwert >=  160 AND sliderwert <  165 THEN Radiuswert = 400
	if sliderwert >=  165 AND sliderwert <  170 THEN Radiuswert = 450
	if sliderwert >=  170 AND sliderwert <  175 THEN Radiuswert = 500
	if sliderwert >=  175 AND sliderwert <  180 THEN Radiuswert = 550
	if sliderwert >=  180 AND sliderwert <  185 THEN Radiuswert = 600
	if sliderwert >=  185 AND sliderwert <  190 THEN Radiuswert = 650
	if sliderwert >=  190 AND sliderwert <  195 THEN Radiuswert = 700
	if sliderwert >=  195 AND sliderwert <  200 THEN Radiuswert = 750
	if sliderwert >=  200 AND sliderwert <  205 THEN Radiuswert = 800
	if sliderwert >=  205 AND sliderwert <  210 THEN Radiuswert = 850
	if sliderwert >=  210 AND sliderwert <  215 THEN Radiuswert = 900
	if sliderwert >=  215 AND sliderwert <  220 THEN Radiuswert = 950
	if sliderwert >=  220 AND sliderwert <  225 THEN Radiuswert = 1000
	if sliderwert >=  225 AND sliderwert <  230 THEN Radiuswert = 1050
	if sliderwert >=  230 AND sliderwert <  235 THEN Radiuswert = 1100
	if sliderwert >=  235 AND sliderwert <  240 THEN Radiuswert = 1200
	if sliderwert >=  240 AND sliderwert <  245 THEN Radiuswert = 1300
	if sliderwert >=  245 AND sliderwert <  250 THEN Radiuswert = 1400
	if sliderwert >=  250 AND sliderwert <= 255 THEN Radiuswert = 1500
End Function


Sub Help
	'** Start Dialog Anleitung **
	FF_AddDialog "Anleitung",260,250
	FF_AddControl "Anleitung","helpedit","EDIT",0,0,260,233
	FF_SetControlStyle "Anleitung","helpedit", 2097152
	FF_AddControl "Anleitung","OK","BUTTON",224,236,33,11
	'** End Dialog Anleitung **
		
	if not KBvorhanden then	
		Call KurzbeschreibungLesen
	End If
	FF_SetControl "Anleitung","helpedit", Kurzbeschreibung
	
	do								' Auswertung Button im Dialog
		Taste2 = FF_ShowDialog("Anleitung")
		Select Case Taste2
			Case "OK", "CANCEL"
				FF_CloseDialog "Anleitung"
				Exit Sub
		End Select
	loop
End Sub

'** Start Kurzbeschreibung *********************************
'Umfeldsuche
'====================================================
'
'Es werden alle Bilder ermittelt, die in einem bestimmten Umkreis um einen gegebenen geografischen Punkt aufgenommen wurden. 
'
'Im Bereich Suchpfad wird die Bilder bestimmt, die durchsucht werden sollen. Voreingestellt ist das aktuelle Computer-Verzeichnis. Per Ordner kann ein abweichender Ablageort gewhlt werden, wahlweise mit oder ohne den Unterordnern in beliebiger Tiefe.
'
'Im Bereich Suchkreis festlegen wird der Mittelpunkt des Suchkreises bestimmt. Die Koordinaten dieses Punktes knnen wahlweise dem (ersten) markierten Bild in der Computer-Ansicht, dem im Arbeitsbereich geladenen Bild oder der Zwischenablage entnommen werden.
'
'ber den Schieberegler wird nun der Radius des Suchkreises bestimmt, in Stufen von 0,1 km bis maximal 1.500 km. 
'
'Im rechten Bereich wird die geografische Lage und Gre des Suchkreises visualisiert. Die Darstellung kann im Bereich Kartentyp angepasst werden, auf das Suchergebnis hat das keinen Einfluss.
'
'Der Button Suche startet die Verarbeitung. Im ersten Schritt werden alle Bilder im Suchpfad ermittelt. Im zweiten Schritt wird fr diejenigen Bilder, in deren EXIF-Daten der geografische Aufnahmeort hinterlegt ist, geprft, ob sie innerhalb des Suchkreises aufgenommen wurden. 

'Die Treffer werden in der Bilderliste Umfeldsuche gesammelt und knnen dort spter weiterverarbeitet werden.
'
'[Andreas Kleingnther  2020]
'** Ende Kurzbeschreibung **********************************

Sub KurzbeschreibungLesen
	on error resume next
	Const ForReading = 1
	Dim Skript, Anfang, Ende, Zeile
	
	Set objFS = CreateObject("Scripting.FileSystemObject")	 ' FileSystemObject
	Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)
	
	if err.number = 53 then
		msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   	"Die Kurzbeschreibung kann daher nicht angezeigt werden.",,"Meldung"
		exit sub
	end if
		
	Do While Skript.AtEndOfStream <> True
		Zeile = Skript.ReadLine
		
		if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
		if Ende then exit do
		
		if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
		if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
		
		if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	Loop
	if Anfang and Ende then KBvorhanden = true
	Skript.Close
End Sub
